package com.rjconsultores.ventaboletos.web.gui.controladores.configuracioneccomerciales;

import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.List;

import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.zhtml.Filedownload;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.InputEvent;
import org.zkoss.zul.Combobox;
import org.zkoss.zul.Comboitem;
import org.zkoss.zul.Intbox;

import com.rjconsultores.ventaboletos.vo.configuracioneccomerciales.ConfigCoordenadas;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderConfigLayoutImpressaoBoleto;

@Controller("configLayoutImpressaoBoletoController")
@Scope("prototype")
public class ConfigLayoutImpressaoBoletoController extends MyGenericForwardComposer {

	private static final long serialVersionUID = 1L;
	private MyListbox campoCoordenadasList;
	private Combobox cmbCampo;
	private Intbox txtLinha;
	private Intbox txtColuna;
	private Integer linha;
	private Integer coluna;
	private List<ConfigCoordenadas> lsConfigCoordenadas;

	@Override
	public void doAfterCompose(Component comp) throws Exception {
		super.doAfterCompose(comp);
		linha = 0;
		coluna = 0;
		txtLinha.setValue(linha);
		txtColuna.setValue(coluna);

		lsConfigCoordenadas = new ArrayList<ConfigCoordenadas>();

		campoCoordenadasList.setItemRenderer(new RenderConfigLayoutImpressaoBoleto());
	}

	public void onClick$btnSalvar(Event ev) throws IOException {

		StringBuilder txt = new StringBuilder();
		for (ConfigCoordenadas c : lsConfigCoordenadas) {
			txt.append(c.getCampo()).append(".linha=").append(c.getLinha()).append("\n");
			txt.append(c.getCampo()).append(".coluna=").append(c.getColuna()).append("\n");
		}

		String nomeArquivo = "coordenadas.properties";

		FileOutputStream stream = new FileOutputStream(nomeArquivo);
		stream.flush();
		stream.write(txt.toString().getBytes());
		stream.close();

		InputStream is = new FileInputStream(nomeArquivo);
		Filedownload.save(is, "application/properties", nomeArquivo);
	}

	public void onClick$btnAddCampoCoordenadas(Event ev) {
		String campo = "VAZIO";
		String lbCampo = cmbCampo.getText();
		Comboitem cbiCampo = cmbCampo.getSelectedItem();
		if (cbiCampo != null) {
			campo = (String) cbiCampo.getValue();
		}

		Integer linha = txtLinha.getValue();
		Integer coluna = txtColuna.getValue();

		ConfigCoordenadas configCoordenadas = new ConfigCoordenadas();
		configCoordenadas.setLbCampo(lbCampo);
		configCoordenadas.setCampo(campo);
		configCoordenadas.setLinha(linha);
		configCoordenadas.setColuna(coluna);

		if ((!campo.equals("VAZIO")) && (linha != null) && (coluna != null)) {
			if (!lsConfigCoordenadas.contains(configCoordenadas)) {
				lsConfigCoordenadas.add(configCoordenadas);

				campoCoordenadasList.setData(lsConfigCoordenadas);

				cmbCampo.setSelectedItem(null);
				txtLinha.setValue(null);
				txtColuna.setValue(null);
			}
		}
	}

	public void onClick$btnRemoverCampoCoordenadas(Event ev) {
		ConfigCoordenadas configCoordenadas = (ConfigCoordenadas) campoCoordenadasList.getSelected();

		lsConfigCoordenadas.remove(configCoordenadas);

		campoCoordenadasList.setData(lsConfigCoordenadas);
	}

	public void onChanging$txtLayout(InputEvent ev) {
		if (ev.getValue().endsWith("\n")) {
			linha = linha + 1;
			txtLinha.setValue(linha);

			coluna = 0;
		} else if (ev.getValue().endsWith(" ")) {
			coluna = coluna + 1;
		} else {
			linha = 0;
			coluna = 0;

			txtLinha.setValue(linha);
		}

		txtColuna.setValue(coluna);
	}
}
